#include <LiquidCrystal.h> //подключаем библиотеку работы с ЖКИ
#include <OneWire.h> //подключаем библиотеку работы с 1-wire

// инициализация библиотеки дисплея. Аргументы - пины на которые подключен LCD
LiquidCrystal lcd(12, 11, 5, 4, 3, 2);
OneWire ds(10); //инициализация 1W. вывод DQ датчиков будет подключен на 10 пин

float T;        //переменная для хранения температуры

void setup() {
  // говорим сколько строк и столбцов в нашем дисплее
  lcd.begin(16, 2);
  // печатаем строку
  lcd.print("homedistiller.ru");
}

void loop() {
  byte data[12]; // массив для хранения принимаемых от датчика данных
  byte i;        
   //работа с 1Wire
  ds.reset();            // любой обмен начинается с импульса reset
  ds.write(0xCC,1);      // т.к. датчик пока один то будем обращаться к нему не по 
                         // адресу, а используя команду "пропуск ROM" (0xCC) 
  ds.write(0x44,1);      // 0x44 - команда на конвертирование температуры
  delay(1000);           // ждем 1 с (время на конвертацию температуры)
  ds.reset();
  ds.write(0xCC,1);      // пропуск ROM
  ds.write(0xBE);        // команда на считывание ОЗУ датчика

  for ( i = 0; i < 9; i++) {           // считываем 9 байт (достаточно 2-х)
    data[i] = ds.read();
  }

  T = float((data[1] << 8) + data[0])/16; //конвертируем 2 байта в десятичное значение температуры

  lcd.setCursor(0, 1);   // устанавливаем курсор во вторую строку (нумерация с 0) в 0 столбец
  lcd.print(" T = ");    // выводим "Т=" на экран
  lcd.print(T);     // в следующей позиции будет печататься температура
  
}

